SystemOrganization addCategory: #VolunteerMPlace!

Object subclass: #CollectionSingleton
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

CollectionSingleton class
	instanceVariableNames: 'soleInstance'!

!CollectionSingleton commentStamp: 'RG 10/6/2012 15:04' prior: 0!
Singleton of a collection of objects!

CollectionSingleton class
	instanceVariableNames: 'soleInstance'!

!CollectionSingleton class methodsFor: 'as yet unclassified' stamp: 'RG 10/6/2012 15:07'!
default
	"Get the unique instance"

	(soleInstance isNil) ifTrue: [soleInstance := self basicNew initialize].
	^ soleInstance! !

!CollectionSingleton class methodsFor: 'as yet unclassified' stamp: 'RG 10/6/2012 15:06'!
new
	"comment stating purpose of message"

	self error: 'Cannot create a new instance.'! !

!CollectionSingleton class methodsFor: 'as yet unclassified' stamp: 'RG 10/6/2012 15:07'!
reset
	"Reset the unique instance to nil"

	soleInstance := nil.! !

!CollectionSingleton methodsFor: 'editing' stamp: 'RG 10/6/2012 15:16'!
add: anObject
	"Adds an element to the collection
	 returns true or false depending on the outcome of the operation."
	[ list add: anObject. ]
	on: Exception
	do: [:ex | ^false. ].
	^true.! !

!CollectionSingleton methodsFor: 'gets' stamp: 'RG 10/6/2012 16:08'!
collection
	"Return the collection of objects in the system"
	^list.! !

!CollectionSingleton methodsFor: 'initialize-release' stamp: 'RG 10/6/2012 15:11'!
initialize
	"Initialize the list of objects"
	list := OrderedCollection new.! !

!CollectionSingleton methodsFor: 'editing' stamp: 'RG 10/6/2012 15:15'!
remove: anObject
	"remove a collection from the list
	 returns true or false depending on the outcome of the operation."
	| index |
	[index := (list find: anObject).
	(index isNil) ifFalse: [list removeAt: index]. ]
	on: Exception
	do: [:ex | ^false. ].
	^true.! !

!CollectionSingleton methodsFor: 'editing' stamp: 'RG 10/6/2012 15:19'!
update: anObject
	"Updates an element of the collection
	 returns true or false depending on the outcome of the operation."
	| result |
	result := self remove: anObject.
	(result) ifTrue: [
		result := self add: anObject.	
	].
	^result.! !

CollectionSingleton subclass: #SkillCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!SkillCollection commentStamp: 'RG 10/6/2012 15:21' prior: 0!
Collection of Skills of the system!

!SkillCollection methodsFor: 'editing' stamp: 'RG 10/6/2012 15:25'!
addSkill: aSkill
	"Set the value of taskCollection"
	| result |
	result := (super add: aSkill).
	(result) ifTrue: [ Transcript cr ; show: (aSkill name), ' added in Skills'. ].! !

!SkillCollection methodsFor: 'editing' stamp: 'RG 10/6/2012 15:28'!
removeSkill: aSkill
	"removes a skill from the collection"
	| result |
	result := super remove: aSkill.
	(result) ifTrue: [ Transcript cr ; show: (aSkill name), ' removed from Skills'. ].

	! !

!SkillCollection methodsFor: 'editing' stamp: 'RG 10/6/2012 15:30'!
updateSkill: aSkill
	"Updates a skill from the collection"
	| result |
	result := super update: aSkill.
	( result ) ifTrue: [ Transcript cr ; show: (aSkill name), ' updated'.  ]! !

CollectionSingleton subclass: #VolunteerCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!VolunteerCollection commentStamp: 'RG 10/6/2012 15:44' prior: 0!
A collection of volunteers of the system.!

!VolunteerCollection methodsFor: 'editing' stamp: 'RG 10/6/2012 15:47'!
addVolunteer: aVolunteer
	"Add a volunteer to the collection"
	| result |
	result := (super add: aVolunteer).
	(result) ifTrue: [ Transcript cr ; show: (aVolunteer name), ' added in Volunteers'. ].! !

!VolunteerCollection methodsFor: 'editing' stamp: 'RG 10/6/2012 15:46'!
removeVolunteer: aVolunteer
	"removes a volunteer from the collection"
	| result |
	result := super remove: aVolunteer.
	(result) ifTrue: [ Transcript cr ; show: (aVolunteer name), ' removed from Volunteers'. ].! !

!VolunteerCollection methodsFor: 'editing' stamp: 'RG 10/6/2012 15:48'!
updateVolunteer: aVolunteer
	"Updates a skill from the collection"
	| result |
	result := super update: aVolunteer.
	( result ) ifTrue: [ Transcript cr ; show: (aVolunteer name), ' updated'.  ]! !

Object subclass: #Comment
	instanceVariableNames: 'user message date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!Comment commentStamp: 'RG 10/8/2012 15:04' prior: 0!
Represents a user commentary!

!Comment methodsFor: 'gets' stamp: 'RG 10/8/2012 15:09'!
date
	"gets the date of creation of the comment"
	^date.! !

!Comment methodsFor: 'sets' stamp: 'RG 10/8/2012 15:09'!
date: aDate
	"sets the date of the comment"
	date := aDate.! !

!Comment methodsFor: 'initialize-release' stamp: 'RG 10/8/2012 15:12'!
initialize
	"Empty constructor"
	date := nil.
	user := nil.
	message := ''.! !

!Comment methodsFor: 'gets' stamp: 'RG 10/8/2012 15:07'!
message
	"gets the message of the comentary"
	^message! !

!Comment methodsFor: 'sets' stamp: 'RG 10/8/2012 15:08'!
message: aMessage
	"sets the message of the comment"
	message := aMessage.! !

!Comment methodsFor: 'gets' stamp: 'RG 10/8/2012 15:05'!
user
	"gets the user"
	^user! !

!Comment methodsFor: 'sets' stamp: 'RG 10/8/2012 15:06'!
user: aUser
	"sets a user"
	user := aUser! !

Object subclass: #LoginVerifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!LoginVerifier commentStamp: 'RG 10/8/2012 14:29' prior: 0!
Class that verifies the user login!

!LoginVerifier class methodsFor: 'operations' stamp: 'RG 10/8/2012 15:50'!
search: aListOfUsers login: aLogin password: aPassword
	"comment stating purpose of message"
	aListOfUsers do: [ :each |
			((each login = aLogin) and: (each password = aPassword))  ifTrue: [ ^each. ].
		].
	^nil.! !

!LoginVerifier class methodsFor: 'operations' stamp: 'RG 10/8/2012 15:42'!
verify: aLogin password: aPassword
	"Returns the user associated with the Login and Password"
	| instance list result |
	instance := VolunteerCollection default.
	list := instance collection.
	result := self search: list.
	( result isNil ) ifFalse: [ ^result. ]. 
	^nil.
	! !

Object subclass: #Offer
	instanceVariableNames: 'sender receiver message response accepted sentDate responseDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!Offer commentStamp: 'MGH 10/8/2012 16:01' prior: 0!
This class represents an offer.!

!Offer methodsFor: 'as yet unclassified' stamp: 'MGH 10/8/2012 16:36'!
ResponseOffer: aAccepted message: aMessage
	"Send a offer to some user"
	response := aMessage.
	accepted := aAccepted.
	sender addOffer: self.
	responseDate := DateAndTime now.! !

!Offer methodsFor: 'as yet unclassified' stamp: 'MGH 10/8/2012 16:35'!
SendOffer: aSender receiver: aReceiver message: aMessage
	"Send a offer to some user"
	sender := aSender.
	receiver := aReceiver.
	message := aMessage.
	receiver addOffer: self.
	sentDate := DateAndTime now.! !

Object subclass: #Skill
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!Skill commentStamp: 'RG 9/19/2012 20:57' prior: 0!
Represent a skill of a volunteer or needed in a task.!

!Skill methodsFor: 'comparing' stamp: 'RG 10/1/2012 16:06'!
= aSkill
	"Testing Equality"
	^ ((self name) = (aSkill name)).! !

!Skill methodsFor: 'gets' stamp: 'RG 9/19/2012 21:00'!
description
	"Getter of description"
	^description.! !

!Skill methodsFor: 'sets' stamp: 'RG 9/19/2012 21:01'!
description: aDescription
	"Setter of description"
	description := aDescription.! !

!Skill methodsFor: 'initialize-release' stamp: 'RG 9/19/2012 21:04'!
initialize
	"Empty constructor"
	super initialize.
	self name: ''.
	self description: ''.! !

!Skill methodsFor: 'initialize-release' stamp: 'RG 9/19/2012 21:06'!
initialize: aName desc: aDescription
	"Constructor with parameters"
	self name: aName.
	self description: aDescription.! !

!Skill methodsFor: 'gets' stamp: 'RG 9/19/2012 20:58'!
name
	"Getter of a name"
	^name.! !

!Skill methodsFor: 'sets' stamp: 'RG 9/19/2012 20:59'!
name: aName
	"Setter of name"
	name := aName.! !

!Skill methodsFor: 'persistence' stamp: 'RG 10/6/2012 16:22'!
remove
	"remove the skill from the system"
	| instance |
	instance := SkillCollection default.
	instance removeSkill: self.
	Smalltalk snapshot: true andQuit: false.	 ! !

!Skill methodsFor: 'persistence' stamp: 'RG 10/6/2012 16:23'!
save
	"save the skill in the system"
	| skillInstance |
	skillInstance := SkillCollection default.
	skillInstance addSkill: self.
	Smalltalk snapshot: true andQuit: false.	 ! !

!Skill methodsFor: 'persistence' stamp: 'RG 10/6/2012 16:22'!
update
	"updates the information of the skill from the system"
	| instance |
	instance := SkillCollection default.
	instance updateSkill: self.
	Smalltalk snapshot: true andQuit: false.	 ! !

Object subclass: #Task
	instanceVariableNames: 'name description status startDate endDate estimatedTime skills volunteers dependsOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!Task commentStamp: 'BBC 10/2/2012 00:57' prior: 0!
stores a task!

!Task methodsFor: 'comparing' stamp: 'BBC 10/5/2012 19:33'!
= aTask
	"comment stating purpose of message"

	^ (self name = aTask name)! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:55'!
addSkill: aSkill
	"to set the value of skills"
	
	skills add: aSkill.! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:55'!
addVolunteer: aVolunteer
	"to set the value of volunteers"
	
	volunteers add: aVolunteer.
! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 23:13'!
dependsOn
	"get task dependences"

	dependsOn do: [:task | Transcript cr; show: (task name) printString].
! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:55'!
dependsOn: aTask
	"to set task dependences"
	
	 
	dependsOn add: aTask.
	dependsOn do: [:task | ((task status) = 'Open') ifTrue: [self status: 'Frozen'] ].
	! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:29'!
description
	"get task description"

	^ description! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:56'!
description: aString
	"to set the value of description"
	
	description := aString.! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:29'!
endDate
	"get task end date"

	^ endDate! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:56'!
endDate: aString
	"to set the value of endDate"
	
	endDate := aString asDate.! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:30'!
estimatedTime
	"get task estimated time"

	^ estimatedTime! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:56'!
estimatedTime: anInteger
	"to set the value of estimatedTime, in hours"
	
	estimatedTime := anInteger.! !

!Task methodsFor: 'as yet unclassified' stamp: 'RG 10/6/2012 15:02'!
getListOfVolunteers: aListOfVolunteers
	"Sort the list of volunteers by the number of similarities of skills with the task"
	| list temp |
	list := OrderedCollection new.
	aListOfVolunteers do: [ :each | list add: (Association key: each value: (each numberOfSimilarities: skills) ). ].
	temp := list sort: [ :v1 :v2 | (v1 value) >= (v2 value). ].
	^temp collect: [ :each | each key. ].! !

!Task methodsFor: 'gets' stamp: 'BBC 10/5/2012 19:58'!
hasSkill: aSkill
	"Test if contains a skill"

	^(skills includes: aSkill).
! !

!Task methodsFor: 'initialize-release' stamp: 'BBC 10/5/2012 19:54'!
initialize
	"Creates a collection to handle task aspects"
	
	status := 'Open'.
	startDate := Date today.
	skills := Set new.
	volunteers := Set new.
	dependsOn := Set new.! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:30'!
name
	"get task name"

	^ name! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:56'!
name: aString
	"to set the value of name"
	
	name := aString.! !

!Task methodsFor: 'persistence' stamp: 'BBC 10/5/2012 20:13'!
save
	"to write a Task into a file"
	
	| taskInstance |
	
	taskInstance := TaskCollection default.
	taskInstance addTask: self.
	Smalltalk snapshot: true andQuit: false.	 
! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:30'!
skills
	"get task skills"

	skills do: [:skill | Transcript cr; show: (skill name) printString].
! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:30'!
startDate
	"get task start date"

	^ startDate! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:56'!
startDate: aString
	"to set the value of startDate"
	
	startDate := aString asDate.! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:30'!
status
	"get task status"

	^ status! !

!Task methodsFor: 'sets' stamp: 'BBC 10/5/2012 19:56'!
status: aString
	"to set the value of status"
	
	status := aString.! !

!Task methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:30'!
volunteers
	"get task volunteers"

	volunteers do: [:volunteer | Transcript cr; show: (volunteer name) printString].
! !

Object subclass: #TaskCollection
	instanceVariableNames: 'taskCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

TaskCollection class
	instanceVariableNames: 'soleInstance'!

TaskCollection class
	instanceVariableNames: 'soleInstance'!

!TaskCollection class methodsFor: 'instance access' stamp: 'BBC 10/5/2012 19:22'!
default
	"comment stating purpose of message"

	(soleInstance isNil) ifTrue: [soleInstance := self basicNew initialize].
	^ soleInstance! !

!TaskCollection class methodsFor: 'instance creation' stamp: 'BBC 10/5/2012 19:20'!
new
	"comment stating purpose of message"

	self error: 'Cannot implement a new instance.'! !

!TaskCollection class methodsFor: 'reset' stamp: 'BBC 10/5/2012 19:27'!
reset
	"comment stating purpose of message"

	soleInstance := nil.! !

!TaskCollection methodsFor: 'editing' stamp: 'BBC 10/5/2012 20:14'!
addTask: aTask
	"Set the value of taskCollection"

	taskCollection add: aTask.
	Transcript cr ; show: (aTask name), ' added in Tasks'.! !

!TaskCollection methodsFor: 'initialize-release' stamp: 'BBC 10/5/2012 19:23'!
initialize
	"comment stating purpose of message"

	taskCollection := OrderedCollection new.! !

!TaskCollection methodsFor: 'editing' stamp: 'BBC 10/5/2012 20:14'!
removeTask: aTask
	"Set the value of taskCollection"
	
	| taskIndex |
	
	[taskIndex := (taskCollection find: aTask).
	(taskIndex isNil) ifFalse: [taskCollection removeAt: taskIndex].
	Transcript cr ; show: (aTask name), ' removed from Tasks']
	on: Exception
	do: [:ex | Transcript cr ; show: 'This task was not created yet.']! !

!TaskCollection methodsFor: 'editing' stamp: 'BBC 10/5/2012 19:47'!
updateTask: aTask
	"Set the value of taskCollection"
	
	
	self removeTask: aTask.
	self addTask: aTask.
	Transcript cr ; show: (aTask name), ' updated'. ! !

Object subclass: #User
	instanceVariableNames: 'login password name email photo inbox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!User commentStamp: 'shout 10/2/2012 18:25' prior: 0!
User of the system!

User subclass: #Admin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!Admin commentStamp: 'shout 10/2/2012 18:33' prior: 0!
Admin of the system!

User subclass: #Coordinator
	instanceVariableNames: 'organization coordinatedProjects coordinatorCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!Coordinator commentStamp: 'BBC 9/22/2012 19:14' prior: 0!
stores a coordinator!

!Coordinator methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:32'!
addCoordinatedProject: aProject
	"to set the value of coordinatedProjects"
	
	coordinatedProjects add: aProject.
	coordinatorCollection at: #coordinatedProjects put: coordinatedProjects.

! !

!Coordinator methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:32'!
coordinatedProjects
	"get coordinator coordinated projects"

	coordinatedProjects do: [:project | Transcript cr; show: (project name) printString].! !

!Coordinator methodsFor: 'create/remove/edit' stamp: 'BBC 10/3/2012 19:18'!
createProject: projectName
	"creates a new Project"

	| aProject|
	
	"Project Aspects"
	aProject := VolunteerProject new.
	aProject name: projectName.
	aProject addCoordinator: name.
	
	"Coordinator Aspects"
	(coordinatedProjects = nil) 
		ifTrue: [coordinatedProjects := Set with: projectName]
		ifFalse: [coordinatedProjects add: projectName].
			
	"Persistence"
	aProject save.
	
	^ aProject
	

	
	! !

!Coordinator methodsFor: 'create/remove/edit' stamp: 'BBC 10/1/2012 01:06'!
deleteProject: aProject
	"to delete a project"

	| fileName fileOps|
	
	fileName := '/Users/bruno/Desktop/Volunteers/', aProject, '.txt'.
	fileOps := FileDirectory new. 
	fileOps deleteFileNamed: fileName.
	Transcript cr; show: fileName, ' removed.'

	
	

	

	
	! !

!Coordinator methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:32'!
email
	"get coordinator email"

	^ email! !

!Coordinator methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:32'!
email: aString
	"to set the value of email"
	
	email := aString.
	coordinatorCollection at: #email put: aString.! !

!Coordinator methodsFor: 'initialize-release' stamp: 'BBC 9/23/2012 14:44'!
initialize
	"Creates a collection to handle coordinator aspects"
	
	coordinatedProjects := Set new.
	coordinatorCollection := Dictionary newFrom: {#name->nil. #email->nil. 												                                                                              #organization->nil.#coordinatedProjects->coordinatedProjects}.
	
! !

!Coordinator methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:32'!
name
	"get coordinator name"

	^ name! !

!Coordinator methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:33'!
name: aString
	"to set the value of name"
	
	name := aString.
	coordinatorCollection at: #name put: aString.! !

!Coordinator methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:32'!
organization
	"get coordinator organization"

	^ organization! !

!Coordinator methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:33'!
organization: aString
	"to set the value of organization"
	
	organization := aString.
	coordinatorCollection at: #organization put: aString.! !

!Coordinator methodsFor: 'create/remove/edit' stamp: 'BBC 10/3/2012 20:29'!
readProject: projectName
	"to read project args"

	| fileName fileStream line |
	
	fileName := '/Users/bruno/Desktop/Volunteers/', projectName, '.txt'.
	fileStream := FileStream fileNamed: fileName.
	[fileStream atEnd] whileFalse: [line := fileStream nextLine. Transcript cr; show: (line)].
	
	

	

	
	! !

!Coordinator methodsFor: 'persistence' stamp: 'BBC 10/3/2012 23:21'!
save
	"to write a Coordinator into a file"

	| fileName fileStream |
	
	fileName := '/Users/bruno/Desktop/Volunteers/', name, '.txt'.
	fileStream := FileStream forceNewFileNamed: fileName.
	fileStream nextPutAll: 'Name: ', (coordinatorCollection at: #name) printString; cr.
	fileStream nextPutAll: 'Email: ', (coordinatorCollection at: #email) printString; cr.
	fileStream nextPutAll: 'Organization: ', (coordinatorCollection at: #organization) printString; cr.
	fileStream nextPutAll: 'Coordinated Projects: '.
	coordinatedProjects do: [:project | fileStream nextPutAll: (project name) printString].
	fileStream close.
	Transcript cr; show: fileName, ' saved.'! !

!User methodsFor: 'as yet unclassified' stamp: 'MGH 10/8/2012 16:10'!
addOffer: message offer: aOffer
	"Add an offer into the inbox"
	[ inbox add: aOffer.]
	on: Exception
	do: [:ex | ^false. ].
	^true.! !

!User methodsFor: 'gets' stamp: 'shout 10/7/2012 22:53'!
email
	"get user email"

	^ email! !

!User methodsFor: 'sets' stamp: 'RG 10/8/2012 14:21'!
email: aEmail
	"set email"
	email := aEmail.! !

!User methodsFor: 'gets' stamp: 'RG 10/8/2012 14:23'!
login
	^login.! !

!User methodsFor: 'sets' stamp: 'RG 10/8/2012 14:23'!
login: aLogin
	"sets login"
	login := aLogin! !

!User methodsFor: 'gets' stamp: 'shout 10/7/2012 22:50'!
name
	^name.! !

!User methodsFor: 'sets' stamp: 'shout 10/7/2012 22:50'!
name: aName
	"comment stating purpose of message"
	name := aName.! !

!User methodsFor: 'gets' stamp: 'RG 10/8/2012 14:25'!
password
	^password! !

!User methodsFor: 'sets' stamp: 'RG 10/8/2012 14:26'!
password: aPassword
	"sets password"
	password := aPassword.! !

!User methodsFor: 'as yet unclassified' stamp: 'MGH 10/8/2012 16:24'!
responseOffer: message offer: aOffer accepted: aAccepted
	"Response an offer"
	| index |
	aOffer ResponseOffer: aAccepted message. 
	[index := (inbox find: aOffer).
	(index isNil) ifFalse: [inbox removeAt: index]. ]
	on: Exception
	do: [:ex | ^false. ].
	^true.! !

User subclass: #Volunteer
	instanceVariableNames: 'skills disponibility availability workTime finishedTasks finishedProjects birthday'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!Volunteer commentStamp: 'RG 9/19/2012 21:15' prior: 0!
Represents a volunteer.!

!Volunteer methodsFor: 'comparing' stamp: 'RG 10/6/2012 15:55'!
= aVolunteer
	"Comparing volunteers"
	^(self name = aVolunteer name)! !

!Volunteer methodsFor: 'operation' stamp: 'RG 10/1/2012 16:07'!
addSkill: aSkill
	"Add a skill to the volunteer"
	(self hasSkill: aSkill) ifFalse: [ skills add: aSkill. ]! !

!Volunteer methodsFor: 'gets' stamp: 'RG 9/19/2012 21:41'!
availability
	"Getter availability"
	^availability.! !

!Volunteer methodsFor: 'sets' stamp: 'RG 9/19/2012 21:43'!
availability: anAvailability
	"Setter of availability"
	availability := anAvailability.! !

!Volunteer methodsFor: 'gets' stamp: 'RG 9/19/2012 21:37'!
birthday
	"Getter of birthday"
	^birthday.! !

!Volunteer methodsFor: 'sets' stamp: 'RG 9/19/2012 21:38'!
birthday: aBirthday
	"Setter of Birthday"
	birthday := aBirthday.! !

!Volunteer methodsFor: 'as yet unclassified' stamp: 'shout 10/2/2012 21:46'!
createAccount: aLogin pass: aPwd name: aName email: aEmail photo: aPhoto skills: aSkills birthday: aBirthDay
	"Create an volunteer account"
	login := aLogin.
	password := aPwd.
	name := aName.
	email := aEmail.
	photo := aPhoto.
	skills := aSkills.
	disponibility := True.
	availability := True.
	workTime := 0.
	finishedTasks := 0.
	finishedProjects := 0.
	birthday := aBirthDay.! !

!Volunteer methodsFor: 'gets' stamp: 'RG 9/19/2012 21:39'!
disponibility
	"Getter of disponibility"
	^disponibility.! !

!Volunteer methodsFor: 'sets' stamp: 'RG 9/19/2012 21:41'!
disponibility: aDisponibility
	"Setter of disponibility"
	disponibility := aDisponibility.! !

!Volunteer methodsFor: 'gets' stamp: 'RG 9/19/2012 21:46'!
finishedProjects
	"Getter finishedProjects"
	^finishedProjects.! !

!Volunteer methodsFor: 'sets' stamp: 'RG 9/19/2012 21:47'!
finishedProjects: numberFinished
	"Setter finishedPrijects"
	finishedProjects := numberFinished.! !

!Volunteer methodsFor: 'gets' stamp: 'RG 9/19/2012 21:49'!
finishedTasks
	"Getter finishedTasks"
.	^finishedTasks.! !

!Volunteer methodsFor: 'sets' stamp: 'RG 9/19/2012 21:49'!
finishedTasks: numberFinished
	"Setter finished Tasks"
	finishedTasks := numberFinished.! !

!Volunteer methodsFor: 'operation' stamp: 'RG 10/1/2012 16:06'!
hasSkill: aSkill
	"Test if has an specific skill"
	^ (skills includes: aSkill).! !

!Volunteer methodsFor: 'initialize-release' stamp: 'RG 10/1/2012 14:13'!
initialize
	"Constructor"
	skills := OrderedCollection new.
	disponibility := ''.
	availability := false.
	workTime := ''.
	finishedTasks := 0.
	finishedProjects := 0.
	birthday := Date new.
	name := ''.! !

!Volunteer methodsFor: 'operation' stamp: 'RG 10/1/2012 16:05'!
numberOfSimilarities: aListOfSkills
	"Given a list of skills, gets the quantity of those that the volunteer posses"
	| count |
	count := 0.
	aListOfSkills do: [ :aSkill |
		( self hasSkill: aSkill ) ifTrue: [ count := count + 1. ].
	].
	^count.! !

!Volunteer methodsFor: 'persistence' stamp: 'RG 10/6/2012 16:16'!
remove
	"remove the volunteer from the system"
	| instance |
	instance := VolunteerCollection default.
	instance removeVolunteer: self.
	Smalltalk snapshot: true andQuit: false.! !

!Volunteer methodsFor: 'persistence' stamp: 'RG 10/6/2012 15:49'!
save
	"save the volunteer in the system"
	
	| volunteerInstance |
	
	volunteerInstance := VolunteerCollection default.
	volunteerInstance addVolunteer: self.
	Smalltalk snapshot: true andQuit: false.	 ! !

!Volunteer methodsFor: 'gets' stamp: 'RG 10/6/2012 15:53'!
skills
	"Return the list of skills"
	^skills! !

!Volunteer methodsFor: 'persistence' stamp: 'RG 10/6/2012 16:19'!
update
	"update the information of the volunteer from the system"
	| instance |
	instance := VolunteerCollection default.
	instance updateVolunteer: self.
	Smalltalk snapshot: true andQuit: false.! !

!Volunteer methodsFor: 'gets' stamp: 'RG 9/19/2012 21:44'!
workTime
	"Getter of worktime"
	^workTime.! !

!Volunteer methodsFor: 'sets' stamp: 'RG 9/19/2012 21:45'!
workTime: aWorkTime
	"comment stating purpose of message"
	workTime := aWorkTime.! !

Object subclass: #VolunteerProject
	instanceVariableNames: 'name type status description coordinators tasks projectCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!VolunteerProject commentStamp: 'BBC 9/23/2012 11:43' prior: 0!
stores a project!

!VolunteerProject methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:33'!
addCoordinator: aCoordinator
	"to set the value of coordinators"
	
	coordinators add: aCoordinator.
	projectCollection at: #coordinators put: coordinators.
	! !

!VolunteerProject methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:34'!
addTask: aTask
	"to set the value of tasks"
	
	tasks add: aTask.
	projectCollection at: #tasks put: tasks.! !

!VolunteerProject methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:34'!
coordinators
	"get project coordinators"

	coordinators do: [:coordinator | Transcript cr; show: (coordinator name) printString].! !

!VolunteerProject methodsFor: 'create/remove/edit' stamp: 'BBC 10/2/2012 00:58'!
createTask: taskName
	"creates a new Task"

	| aTask|
	
	"Task Aspects"
	aTask := Task new.
	aTask name: taskName.
	
	"Project Aspects"
	tasks add: aTask.
	
			
	"Persistence"
	aTask save.! !

!VolunteerProject methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:35'!
description
	"get project description"

	^ description! !

!VolunteerProject methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:34'!
description: aString
	"to set the value of description"
	
	description := aString.
	projectCollection at: #description put: aString.! !

!VolunteerProject methodsFor: 'initialize-release' stamp: 'BBC 10/3/2012 15:35'!
initialize
	"Creates a collection to handle project aspects"
	
	status := 'Open'.
	coordinators := Set new.
	tasks := Set new.
	projectCollection := Dictionary newFrom: {#name->nil. #description->nil. #type->nil. #status->status. 
											     #coordinators->nil. #tasks->nil}.
	! !

!VolunteerProject methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:35'!
name
	"get project name"
	
	^ name! !

!VolunteerProject methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:34'!
name: aString
	"to set the value of name"
	
	name := aString.
	projectCollection at: #name put: aString.! !

!VolunteerProject methodsFor: 'persistence' stamp: 'BBC 10/5/2012 18:22'!
save
	"to write a Project into a file"

	| fileName fileStream |
	
	fileName := '/Users/bruno/Desktop/Volunteers/', name, '.txt'.
	fileStream := FileStream forceNewFileNamed: fileName.
	fileStream nextPutAll: 'Name: ', (projectCollection at: #name) printString; cr.
	fileStream nextPutAll: 'Description: ', (projectCollection at: #description) printString; cr.
	fileStream nextPutAll: 'Type: ', (projectCollection at: #type) printString; cr.
	fileStream nextPutAll: 'Status: ', (projectCollection at: #status) printString; cr.
	fileStream nextPutAll: 'Coordinators: '.
	coordinators do: [:coordinator | fileStream nextPutAll: (coordinator name) printString].
	fileStream nextPutAll: '' ; cr.
	fileStream nextPutAll: 'Tasks: '.
	tasks do: [:task | fileStream nextPutAll: (task name) printString].
	fileStream close.
	Transcript cr; show: fileName, ' saved.'.
	
	 Smalltalk snapshot: true andQuit: false. Transcript cr; show:'Snapshot Taken!!'
! !

!VolunteerProject methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:35'!
status
	"get project status"

	^ status! !

!VolunteerProject methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:34'!
status: aString
	"to set the value of status"
	
	status := aString.
	projectCollection at: #status put: aString.! !

!VolunteerProject methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:35'!
tasks
	"get project tasks"

	tasks do: [:task | Transcript cr; show: (task name) printString].! !

!VolunteerProject methodsFor: 'gets' stamp: 'BBC 10/3/2012 15:35'!
type
	"get project type"

	^ type! !

!VolunteerProject methodsFor: 'sets' stamp: 'BBC 10/3/2012 15:34'!
type: aString
	"to set the value of type"
	
	type := aString.
	projectCollection at: #type put: aString.! !

TestCase subclass: #BrunoTest
	instanceVariableNames: 'coordinator project task coordStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VolunteerMPlace'!

!BrunoTest methodsFor: 'running' stamp: 'BBC 10/3/2012 22:48'!
setUp
	"set up test environment"
	
	coordinator := Coordinator new.
	coordinator name: 'Bruno' ;
				 email: 'collaco.bruno@gmail.com' ;
				 organization: 'IAG-USP'.
				
	project := VolunteerProject new.	
	project name: 'Weekend Classes' ;
		      description: 'This project aims to help students by giving extra classes on the weekends' ;
		      type: 'Extra Classes'. 	
			
	task := Task new.	
	task name: 'Give Classes' ;
		  description: 'to give classes at weekends...' ;
		  endDate: '2012-12-1' ;
              estimatedTime: 40. ! !

!BrunoTest methodsFor: 'creating' stamp: 'BBC 10/3/2012 21:22'!
testCreatingCoordinator
	"comment stating purpose of message"

	| fileName fileStream|
	
	coordinator name: 'Bruno' ;
				 email: 'collaco.bruno@gmail.com' ;
				 organization: 'IAG-USP' ;
				 save.

	
	fileName := '/Users/bruno/Desktop/Volunteers/', (coordinator name), '.txt'.
	fileStream := FileStream fileNamed: fileName.
	
	self deny: (fileStream = nil).

				
				
	! !

!BrunoTest methodsFor: 'creating' stamp: 'BBC 10/3/2012 20:42'!
testCreatingProject
	"comment stating purpose of message"
	
	| fileName fileStream|
	
	project name: 'Weekend Classes' ;
		      description: 'This project aims to help students by giving extra classes on the weekends' ;
		      type: 'Extra Classes' ;
		      save. 

	fileName := '/Users/bruno/Desktop/Volunteers/', (project name), '.txt'.
	fileStream := FileStream fileNamed: fileName.
	
	self deny: (fileStream = nil).! !

!BrunoTest methodsFor: 'creating' stamp: 'BBC 10/3/2012 21:28'!
testCreatingTask
	"comment stating purpose of message"
	
	| fileName fileStream|
	
	task name: 'Give Classes' ;
		  description: 'to give classes at weekends...' ;
		  endDate: '2012-12-1' ;
              estimatedTime: 40 ; 
		  save. 

	fileName := '/Users/bruno/Desktop/Volunteers/', (task name), '.txt'.
	fileStream := FileStream fileNamed: fileName.
	
	self deny: (fileStream = nil).! !

!BrunoTest methodsFor: 'creating' stamp: 'BBC 10/3/2012 23:50'!
testDependeces
	"comment stating purpose of message"
	
	| firstTask|
	
	firstTask := Task new.
	firstTask name: 'Needed Task'.
	
	task dependsOn: firstTask.
	
	self assert: ((task status) = 'Frozen').
! !

!BrunoTest methodsFor: 'creating' stamp: 'BBC 10/3/2012 23:03'!
testzCoordProjTask
	"comment stating purpose of message"
	
	| coordFile coordStream volunteerFile volunteerStream taskFile taskStream |
	
	coordinator addCoordinatedProject: project.
	
	project addCoordinator: coordinator ;
	            addTask: task.
	
	task addSkill: 'teaching' ;
		 addVolunteer: 'Isaac Newton'.

	coordinator save.
	project save.
	task save.
	
	coordFile := '/Users/bruno/Desktop/Volunteers/', (coordinator name), '.txt'.
	coordStream := FileStream fileNamed: coordFile.
	volunteerFile := '/Users/bruno/Desktop/Volunteers/', (project name), '.txt'.
	volunteerStream := FileStream fileNamed: volunteerFile.
	taskFile := '/Users/bruno/Desktop/Volunteers/', (task name), '.txt'.
	taskStream := FileStream fileNamed: taskFile.
	
	self deny: (coordStream = nil & volunteerStream = nil & taskStream = nil).! !
